diff --git a/src/include/access/zheap.h b/src/include/access/zheap.h
index f463543..e9149bf 100644
--- a/src/include/access/zheap.h
+++ b/src/include/access/zheap.h
@@ -22,7 +22,7 @@
 #include "utils/rel.h"
 #include "utils/snapshot.h"
 
-#define MAX_PAGE_TRANS_INFO_SLOTS	4
+#define MAX_PAGE_TRANS_INFO_SLOTS	14
 
 /*
  * We need tansactionid and undo pointer to retrieve the undo information
diff --git a/src/include/access/zhtup.h b/src/include/access/zhtup.h
index 4dec7d7..2bb63f3 100644
--- a/src/include/access/zhtup.h
+++ b/src/include/access/zhtup.h
@@ -25,7 +25,7 @@
 /* valid values for transaction slot is between 0 and MAX_PAGE_TRANS_INFO_SLOTS */
 #define InvalidXactSlotId	(-1)
 /* we use frozen slot to indicate that the tuple is all visible now */
-#define	ZHTUP_SLOT_FROZEN	0x007
+#define	ZHTUP_SLOT_FROZEN	0x00F
 
 /*
  * Heap tuple header.  To avoid wasting space, the fields should be
@@ -87,7 +87,7 @@ typedef ZHeapTupleData *ZHeapTuple;
  * information stored in t_infomask2:
  */
 #define ZHEAP_NATTS_MASK			0x07FF	/* 11 bits for number of attributes */
-#define ZHEAP_XACT_SLOT				0x3800	/* 3 bits (12, 13 and 14) for transaction slot */
+#define ZHEAP_XACT_SLOT				0x7800	/* 4 bits (12, 13, 14 and 15) for transaction slot */
 #define	ZHEAP_XACT_SLOT_MASK		0x000B	/* 11 - mask to retrieve transaction slot */
 
 
